; ##############################################################################
; ##############################################################################
; ##############################################################################
; SPCR => SPIE SPE DORD MSTR CPOL CPHA SPR1 SPR0 (SPI Control Register)		
; 																			
; SPIE: SPI Interrupt Enable												
; SPE:  SPI Enable															
; DORD: Data Order															
; MSTR: Master/Slave Select													
; CPOL: Clock Polarity														
; CPHA: Clock Phase															
;						   Leading Edge 	Trailing Edge 		SPI Mode	
;		CPOL = 0, CPHA = 0 Sample (Rising) 	Setup (Falling) 		0		
;		CPOL = 0, CPHA = 1 Setup (Rising) 	Sample (Falling) 		1		
;*		CPOL = 1, CPHA = 0 Sample (Falling) Setup (Rising) 			2		
;		CPOL = 1, CPHA = 1 Setup (Falling) 	Sample (Rising) 		3		
; SPR1: SPI Clock Rate Select 1												
; SPR0: SPI Clock Rate Select 0												
; 		SPR1 SPR0 SCK Frequency												
;  		0    0   fosc/4														
;  		0    1   fosc/16													
;  		1    0   fosc/64													
;  		1    1   fosc/128													
;																			
; Enable SPI, SLAVE															
SPI_INITIALISIERUNG:

	ldi temp,(1<<SPIE)|(1<<SPE)|(0<<DORD)|(0<<MSTR)|(1<<CPOL)|(0<<CPHA)|(0<<SPR1)|(0<<SPR0)
	out SPCR,temp

; SPSR => SPIF WCOL - - - - - SPI2X  (SPI Status Register )					
;																			
; SPIF:  SPI Interrupt Flag													
; WCOL:  Write COLlision Flag												
; SPI2X: Double SPI Speed Bit												
;																			
; Double SPI Speed = off													
	ldi temp,(0<<SPI2X)
	out SPSR,temp	


; SPI-CS			
	cbi (SPI_CS_DDR) , (SPI_CS_PIN_NR)				; auf EINGANG	
	sbi (SPI_CS_PORT), (SPI_CS_PIN_NR)				; PULL-UP-ON	
; SPI-SCK			
	cbi (SPI_SCK_DDR), (SPI_SCK_PIN_NR)				; auf EINGANG	
	sbi (SPI_SCK_PORT), (SPI_SCK_PIN_NR)			; PULL-UP-ON	
; SPI-MOSI			
	cbi (SPI_MOSI_DDR),(SPI_MOSI_PIN_NR)			; auf EINGANG	
	sbi (SPI_MOSI_PORT),(SPI_MOSI_PIN_NR)			;
; SPI-MISO			
	cbi (SPI_MISO_DDR),(SPI_MISO_PIN_NR)			; auf AUSGANG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SPI_STC:
	in	 SREG_KOPIE,SREG						; Einlesen des SREG 
	mov  temp_KOPIE,TEMP
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an			
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus   		
;-------------------------------------------------------------------------------
;SPI_SlaveReceive:
; Wait for reception complete
;	sbis SPSR,SPIF
;	rjmp SPI_SlaveReceive


	in SPI_DATA, SPDR		; DATENBYTE EINLESEN			
	ST Z+,SPI_DATA			; im SRAM ablegen				
	; fertig ?				
	cpi ZL,LOW (adr_SPI_DATENBEREICH+1000)
	brne SPI_STC_FERTIG
	cpi ZH,HIGH(adr_SPI_DATENBEREICH+1000)
	brne SPI_STC_FERTIG
	; SPI STOP !			
	out SPCR,NULL
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus			
;-------------------------------------------------------------------------------
SPI_STC_FERTIG:
	out	SREG,SREG_KOPIE				; Wiederherstellen von SREG
	mov TEMP,temp_KOPIE
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################

